#include <iostream>
using namespace std;

int main()
{
	long long koliko_pojela=0,suma_plazmi=0;
	int br_odlazaka, br_prestanka_jela;
	
	cin>>br_odlazaka>>br_prestanka_jela;
	
	long long dan_kupovine[br_odlazaka],kupljena_zaliha[br_odlazaka];
	long long  dan_prestanka[br_prestanka_jela];
	
	for(int i=0;i<br_odlazaka;i++)
	{
		cin>>dan_kupovine[i]>>kupljena_zaliha[i];
	}
	
	for(int j=0;j<br_prestanka_jela;j++)
	{
		cin>>dan_prestanka[j];
			
	}
	int j;
	for(j=0;j<br_prestanka_jela;j++)
	{
		long long dan;
		
		if(dan_prestanka[j]>dan_kupovine[br_odlazaka-1])
		{
			for(int i=0;i<br_odlazaka;i++)
			{	
				if(koliko_pojela+kupljena_zaliha[i]>=dan_prestanka[j])
				{
					koliko_pojela=dan_prestanka[j]-dan_kupovine[i]+1;
					break;
				}
					
				else
					koliko_pojela+=kupljena_zaliha[i];
					
			}
		}
		else	
			for(int i=0, dan=dan_kupovine[0];dan<=dan_prestanka[j]; dan++ )
			{
			
				if(dan==dan_kupovine[i])
				{
					suma_plazmi+=kupljena_zaliha[i];
					i++;
				}
				if(suma_plazmi-1>=0)
				{
					koliko_pojela++;
					suma_plazmi--;
				}
			}
		cout<<koliko_pojela<<endl;
		koliko_pojela=0;
		suma_plazmi=0;
	}
	
	return 0;	
}